
# Scripts for Benchmarks

Some scripts to help generate benchmarks.

* `get-regexlib.py` -- get 5 star rated regex from regexlib.com, output as CSV.
* `generate_word_eqs.py` -- from a CSV of regexlib.com results, generate a set of random WordEQ benchmarks.
* `regex_to_smtlib.py` -- library file contains `regex_to_smtlib` function for converting Python regex into SMTLIB.

For running tests:

* `test-solvers.py` -- run solvers on a directory of benchmarks, produce a CVS file of results for those where Z3 takes more than 10s. Edit the file to insert your local paths to Z3, CVC5, Ostrich, and Sym Parikh.

For processing results:

* `make-graphs.py` -- make LaTeX graphs from the output of `test-solvers.py`

# Benchmarks

There are three benchmark sets.

* `qf_slia/QF_SLIA/2015-Norn` are the Norn benchmarks from SMTCOMP 2022.
* `qf_slia/QF_SLIA/2018-Kepler` are the Kepler benchmarks from SMTCOMP 2022.
* `wordeqs` are the WordEQ benchmarks generated from regexlib.com examples.
