
#ifndef __APP_H__
#define __APP_H__

// for easy debugging
#include <iostream>
#include <vector>

#include "z3++.h"

namespace sym_parikh {
    /**
     * Base class for functions to navigate z3 expr
     */
    class app {
        protected:
            /**
             * Checks if e is an op application
             */
            static bool is_app_of(z3::expr const &e, int op) {
                return e.decl().decl_kind() == op;
            }

            /**
             * Checks if e is an op application and copies args into args
             */
            static bool is_app_of(
                z3::expr const &e,
                int op,
                std::vector<z3::expr> &args
            ) {
                if (e.decl().decl_kind() == op) {
                    int arg_idx = 0;
                    for (z3::expr const &arg : e.args())
                        args.push_back(arg);
                    return true;
                } else {
                    return false;
                }
            }
    };
}

#endif
